// -*- C++ -*-

#pragma once

#include "gather.h"
#include "il_writer_utils.h"
#include "image.h"
#include "kernel.h"
#include "loops.h"
#include "memory.h"
#include "reinterpret.h"

namespace goopax {
namespace impl {
struct utilbase;

template<typename T, typename B>
struct cn_changetype
{
    typedef B type;
};
template<typename T, typename B>
struct cn_changetype<checknan<T>, B>
{
    typedef checknan<B> type;
};


namespace utils {
template<typename OP, typename T, typename size_type>
T minmaxsum(const buffer<T, size_type>& ar, size_type count, size_type start);

template<typename T, typename size_type>
inline T min(const buffer<T, size_type>& ar, const size_type begin, const size_type end);
template<typename T, typename size_type>
inline T max(const buffer<T, size_type>& ar, const size_type begin, const size_type end);
template<typename T, typename size_type>
inline T sum(const buffer<T, size_type>& ar, const size_type begin, const size_type end);

}
}
}
