// -*- C++ -*-


#pragma once

#include "pdefs.h"

#include <cstdint>
#include <vector>

#define HALF_ROUND_STYLE 1 // round to nearest
#define HALF_ROUND_TIES_TO_EVEN 1


#ifndef GOOPAX_DLL_EXPORT
#if defined(_WIN32)

#if defined(BUILDING_GOOPAX)
#define GOOPAX_DLL_EXPORT(V) __declspec(dllexport)
#define GOOPAX_DLL_LOCAL
#else
#define GOOPAX_DLL_EXPORT(V)
#define GOOPAX_DLL_LOCAL
#endif

#else

#if defined(BUILDING_GOOPAX)
#define GOOPAX_DLL_EXPORT(V) __attribute__((__visibility__("default")))
#define GOOPAX_DLL_LOCAL __attribute__((__visibility__("hidden")))
#else
#define GOOPAX_DLL_EXPORT(V)
#define GOOPAX_DLL_LOCAL
#endif

#endif
#endif


#ifndef _MSC_VER
#if (__cplusplus < 201400)
#error "GOOPAX requires C++ standard 14 or newer."
#endif
#endif

#if __cplusplus < 201700 && (!defined(__clang__) || __cplusplus < 201406L)
#define GOOPAX_CONSTEXPR_INSTANTIATION 1
#else
#define GOOPAX_CONSTEXPR_INSTANTIATION 0
#endif


#ifdef __ENVIRONMENT_IPHONE_OS_VERSION_MIN_REQUIRED__
#define GOOPAX_IOS 1
#define GOOPAX_IOS_VERSION __ENVIRONMENT_IPHONE_OS_VERSION_MIN_REQUIRED__
#else
#define GOOPAX_IOS 0
#endif


namespace goopax {
namespace impl {

#ifdef __GNUC__
#define GOOPAX_GCC_ATTRIB(x) __attribute((x))
#define GOOPAX_EXPECT(x, n) __builtin_expect(x, n)
#else
#define GOOPAX_GCC_ATTRIB(x)
#define GOOPAX_EXPECT(x, n) x
#endif


#define GOOPAX_VERSION_ID (GOOPAX_VERSION_MAJOR * 10000 + GOOPAX_VERSION_MINOR * 100 + GOOPAX_VERSION_PATCH)


// FIXME: remove, perhaps
struct INITTEX_REINTERPRET
{};
struct INITTEX_FROMGL
{};
struct INITTEX_IMPL
{};


}
}
