if (${CMAKE_SIZEOF_VOID_P} EQUAL 8)
  if (EXISTS "${CMAKE_CURRENT_LIST_DIR}/goopax64Targets.cmake")
    include("${CMAKE_CURRENT_LIST_DIR}/goopax64Targets.cmake")
  else()
    include("${CMAKE_CURRENT_LIST_DIR}/goopaxTargets.cmake")
  endif()
elseif (${CMAKE_SIZEOF_VOID_P} EQUAL 4)
  if (EXISTS "${CMAKE_CURRENT_LIST_DIR}/goopax32Targets.cmake")
    include("${CMAKE_CURRENT_LIST_DIR}/goopax32Targets.cmake")
  else()
    include("${CMAKE_CURRENT_LIST_DIR}/goopaxTargets.cmake")
  endif()
else()
  include("${CMAKE_CURRENT_LIST_DIR}/goopaxTargets.cmake")
endif()

if (TARGET goopax_export64)
  add_library(goopax_goopax64 INTERFACE)
  target_link_libraries(goopax_goopax64 INTERFACE goopax_export64)
  add_library(goopax::goopax64 ALIAS goopax_goopax64)
endif()

if (TARGET goopax_export32)
  add_library(goopax_goopax32 INTERFACE)
  target_link_libraries(goopax_goopax32 INTERFACE goopax_export32)
  add_library(goopax::goopax32 ALIAS goopax_goopax32)
endif()

if (NOT TARGET goopax::goopax)
  if (TARGET goopax_export)
    add_library(goopax_goopax INTERFACE)
    target_link_libraries(goopax_goopax INTERFACE goopax_export)
    add_library(goopax::goopax ALIAS goopax_goopax)
  endif()
endif()

if (NOT TARGET goopax::goopax)
  if (TARGET goopax_goopax64)
    add_library(goopax::goopax ALIAS goopax_goopax64)
  elseif (TARGET goopax_goopax32)
    add_library(goopax::goopax ALIAS goopax_goopax32)
  elseif (TARGET goopax_goopax)
    add_library(goopax::goopax ALIAS goopax_goopax)
  endif()
endif()
    
